<?php

/**
 * @file
 * Contains \Drupal\video_embed_wistia\Plugin\video_embed_field\Provider\Wistia.
 */

namespace Drupal\video_embed_screencast\Plugin\video_embed_field\Provider;

use Drupal\video_embed_field\ProviderPluginBase;

/**
 * @VideoEmbedProvider(
 *   id = "screencast",
 *   title = @Translation("Screencast")
 * )
 */
class Screencast extends ProviderPluginBase {

  /**
   * {@inheritdoc}
   */
  public function renderEmbedCode($width, $height, $autoplay) {
    return [
      '#type' => 'video_embed_iframe',
      '#provider' => 'screencast',
      '#url' => sprintf('http://www.screencast.com/users/%s', $this->getVideoId()),
      '#query' => [
        'autoplay' => $autoplay
      ],
      '#attributes' => [
        'width' => $width,
        'height' => $height,
        'frameborder' => '0',
        'allowfullscreen' => 'allowfullscreen',
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */

  public function getRemoteThumbnailUrl() {
    return false;
  }

  /**
   * {@inheritdoc}
   */
  public static function getIdFromInput($input) {
    preg_match('/^https?:\/\/(www\.)?(screencast.com)\/(users)\/(?<id>.*)$/', $input, $matches);
    return isset($matches['id']) ? $matches['id'] : FALSE;
  }
}